/*
 * Examples  : Arduino Experiment Examples By....ETT CO.,LTD
 * Program   : Hardware LAB3.4
 * Hardware  : ET-BASE AVR EASY MEGA88/168(Arduino)
 *           : ET-MINI 74HC595 + Character LCD
 *           : -> DIN   = Digital-4(PD4) = Digital Output
 *           : -> LATCH = Digital-7(PD7) = Digital Output
 *           : -> CLOCK = Digital-8(PB0) = Digital Output
 *           : LCD 4 Bit Mode Interface Circuit with 74HC595  
 *           : Pin 1  = GND = GND                             
 *           : Pin 2  = VCC = +5V                             
 *           : Pin 3  = VO  = Contrast Adjust Voltage         
 *           : Pin 4  = RS  = Q1 (Pin 1 of 74HC595)           
 *           : Pin 5  = RW  = Q2 (Pin 2 of 74HC595)           
 *           : Pin 6  = EN  = Q3 (Pin 3 of 74HC595)           
 *           : Pin 7  = D0  = GND                             
 *           : Pin 8  = D1  = GND                             
 *           : Pin 9  = D2  = GND                             
 *           : Pin 10 = D3  = GND                             
 *           : Pin 11 = D4  = Q4 (Pin 4 of 74HC595)           
 *           : Pin 12 = D4  = Q5 (Pin 5 of 74HC595)           
 *           : Pin 13 = D6  = Q6 (Pin 6 of 74HC595)            
 *           : Pin 14 = D7  = Q7 (Pin 7 of 74HC595)             
 *  Function : LCD 4 Bit : Control By SPI-74HC595 Interface
 */

#include <LCDHC595.h>                       // Used 74HC595 Control lCD Library

// Arduino Pins
#define SIN_PIN   4                         // 74HC595 Serial In Pin
#define STR_PIN   7                         // 74HC595 Strobe pin
#define CLK_PIN   8                         // 74HC595 Clock pin

//Create object to Control LCD.  
LCDHC595 lcd = LCDHC595(SIN_PIN, STR_PIN, CLK_PIN); 

// Messages to Display on the LCD
char msgs[5][17] = {">Test Arduino", 
                    ">4 Bit Mode LCD", 
                    ">3 Pin Interface", 
                    ">Use SPI 74HC595", 
                    "By...ETT CO.,LTD"};

void setup() 
{ 
  lcd.Initial();                            // Initial LCD
  lcd.Backlight(1);                         // ON Backlight LED  
}

void loop()
{   
  for (int j = 0; j<5; j++)                 // 5 Message Display
  {  
    lcd.ClearScreen();                      // Clear Screen Display
    lcd.Print("ET-HC595 Library");
    delay(1000);
      
    lcd.SetCursor(0x40);                    // Set Cursor Start Line[2]
    char* msg = msgs[j];                  
    for (int i=0; i<strlen(msg); i++)
    {
      lcd.Print(msg[i]); 
      delay(100);
    }
    delay(1000);
  }
}

